'' turn hypertrm into a video player! sort of.

'' the settings will only really work with bright objects and dark background or viceversa -- i tested this with the symbol '+ in duct tape on a white wall -- it works.

con

   _clkmode  = xtal1 | pll16x 
   _xinfreq  = 5_000_000


obj

debug: "FullDuplexSerialExt"
cam:"propcamera_module"



con

BAUDRATE = 57600

pub start | ch, pixel, pxcnt, pixel2

ch~
dira~ ' all inputs for this guy



'cam.start

trakme := 127
dodisplay := 1

debug.start(31,30,%0000,BAUDRATE)

    
repeat
  debug.stopnoflush
  cam.runonce(true)
  debug.start(31,30,%0000,BAUDRATE)
  lmax~
  lmin := $FF
  lmed~
  pxcnt~
  ch~

'' figure out min, max and average values for scene light
  
  repeat cam#ARRAYSIZE
    pixel := byte[cam.pxladdr(ch++,false)]
    
    if (pixel < 241) and (pixel > 16) ' limits defined by the module so we can have flag values
    
      if pixel > lmax
        lmax := pixel
      if pixel < lmin
        lmin := pixel
      lmed += pixel
      pxcnt++

  lmed := lmed / pxcnt '(lmax+lmin)/2

                              

'' generate tressholds

  if dynlight




     ldiff := (lmax-lmin)/5
     treval[1] := lmin + (ldiff * 1)
     treval[2] := lmin + (ldiff * 2)
     treval[3] := lmin + (ldiff * 3)
     treval[4] := lmin + (ldiff * 4)




  else

     ldiff := constant((240-16)/5) 
     treval[1] := constant(((240-16)/5)*1 + 16)
     treval[2] := constant(((240-16)/5)*2 + 16)
     treval[3] := constant(((240-16)/5)*3 + 16)
     treval[4] := constant(((240-16)/5)*4 + 16)


  ' zero
  ' max
   
'' print ascii-art scene to terminal
  ch~
  trakm := trakme - trakwin
  trakp := trakme + trakwin
  
  if dodisplay

   repeat cam#ARRAYSIZE
    pixel := byte[cam.pxladdr(ch,false)]
    if pixel == $FE
                dodisplay := dodisplay'debug.tx("!")
    elseif pixel == $FF
                debug.tx(13)
                debug.tx(10)
    else
            printasciipixel(pixel)
    ch++
  if autoload
      longmove(@page, cam.frm, cam#ARRAYSIZE/4)  
    
'' go back and do it again
  debug.tx(13)
  debug.tx(10)
  debug.tx(lastch)
  debug.tx(",")
  debug.hex(lmax,2)
  debug.tx(" ")
  debug.hex(lmed,2)
  debug.tx(" ")
  debug.hex(lmin,2)
  debug.tx(",")
  debug.hex(trakme,2)
  debug.tx("(")
  debug.hex(trakwin,2)
  debug.tx(")")
                debug.tx(13)
                debug.tx(10)

  ch := debug.rxcheck
  if ch > -1
     lastch := command := ch
  else
     command~   

  case command
     "i": invert    ' invert for black-on white vs white-on-black displays
     "[": trakme--    ' mark a pixel of this brightness with a special character
     "]": trakme++     ' mark a pixel of this brightness with a special character
     ".": trakwin--   ' inc/dec trakme window
     ",": trakwin++   ' inc/dec trakme window
     "m":        ' toggle tracking MAXIMUMS on/off
          command := trakmax
          trakmax := trakmax[1]
          trakmax[1] := command
     "n":      ' toggle tracking MINIMUMS on/off
          command := trakmin
          trakmin := trakmin[1]
          trakmin[1] := command
          
     "s": longmove(@page, cam.frm, cam#ARRAYSIZE/4) ' save: save a page. Also turns off autoload
          autoload~

     "l": ch~  ' load: print page. 


        repeat cam#ARRAYSIZE
          pixel := page[ch]
          if pixel == $FE
                debug.tx("!")
          elseif pixel == $FF
                debug.tx(13)
                debug.tx(10)
          else
            printasciipixel(pixel)
          ch++

     "d": ch~    ' differences what's being seen now with what's been saved


        repeat cam#ARRAYSIZE
          pixel := byte[cam.pxladdr(ch,false)]
          if pixel == $FE
                debug.tx("!")
          elseif pixel == $FF
                debug.tx(13)
                debug.tx(10)
          else
           pixel2 := page[ch]
           printasciipixel(127 + (pixel/2) - (pixel2/2))
          ch++


     "x": dodisplay := not dodisplay ' display on/off
     "b": dynlight := not dynlight
     "a": autoload := 1 ' save each frame (rolling diff)

     "c": if ansi   ' toggle ascii/ansi displays
             bytemove(@greylevels,string("@*=- XX@M m"), 11)
             ansi~
          else   
             bytemove(@greylevels,string("۲ XXM m"), 11)
             ansi:=1

     "f":
          debug.str(string("Get ready to capture ppm file",13,10))
          debug.stop
          debug.start(31,30,%0000,BAUDRATE)
          debug.rx
          outputppm
          debug.rx
          debug.str(string("Done with ppm output",13,10))
          
             
             
     other: command~   
  command~

  
pub outputppm | pixel, ch



  ch~
  
  debug.str(@magicstr)
  debug.tx(13)
        debug.tx(10)
  debug.dec(cam#COLS-2)
  debug.tx(" ")
  debug.dec(cam#ROWS)
  debug.tx(13)
        debug.tx(10)
  debug.str(@maxcol)
  debug.tx(13)
        debug.tx(10)

  ch~
  repeat cam#ROWS

   repeat cam#COLS
     pixel := cam.pxl(ch)

     

     if pixel < $FF
        debug.tx(pixel)
        debug.tx(pixel)
        debug.tx(pixel)

     ch++

  debug.str(@crlfmag) ' so we know we're done


dat
crlfmag  byte 13,10
magicstr byte "P6",0
maxcol   byte "240",0
pub printasciipixel(caseme)
           case  caseme
                  trakm..trakp:debug.tx(traklevel)
                  lmax: debug.tx(trakmax)
                  lmin: debug.tx(trakmin)
                  $00..treval[1]: debug.tx(greylevels[4])
                  treval[1]..treval[2]: debug.tx(greylevels[3])                                        
                  treval[2]..treval[3]: debug.tx(greylevels[2])
                  treval[3]..treval[4]: debug.tx(greylevels[1])
                  other: debug.tx(greylevels[0])       

var
byte page[cam#ARRAYSIZE]
byte dodisplay
byte autoload
byte ansi
byte dynlight

long trakm,trakp

long trakx
long traky
long trakcnt
pub invert 

temp[0] := greylevels[0]
temp[1] := greylevels[1]
temp[2] := greylevels[2]
temp[3] := greylevels[3]
temp[4] := greylevels[4]   

 greylevels[0] := temp[4]
 greylevels[1] := temp[3]
 greylevels[2] := temp[2]
 greylevels[3] := temp[1]
 greylevels[4] := temp[0]

temp[5] := trakmax
trakmax := trakmin
trakmin := temp[5] 

temp[5] := trakmax[1]
trakmax[1] := trakmin[1]
trakmin[1] := temp[5] 
 

var
byte temp[6]
byte lastch, command
byte trakme
byte trakwin

con


GREY_LEVELS = 5

dat                   
'reylevels byte "0%:` "    ' ASCII from darkest to lightest
greylevels byte "@*=- "
'greylevels byte "۲ "   ' ANSI from darkest to lightest
traklevel  byte "X","X"  ' first is standard, second is highlighted
trakmax    byte "0","+"  ' first is standard, second is highlighted
trakmin    byte " ","-"  ' first is standard, second is highlighted

var
long lmax, lmin, lmed, ldiff, treval[10]
           